# -*- coding: utf-8 -*-

from wtforms import validators as v, StringField
from form_utils import validate_time_interval
from fmtapper_web.frontend.forms import TapperUIBaseForm


class CleanupServiceConfigForm(TapperUIBaseForm):
    store_logs = StringField(u'Время хранения логов сервиса очистки', [v.number_range(min=1)])
    tuner_logs_max_weight = StringField(u'Максимальный объем логов тюнера', [v.number_range(min=1)])
    audio_max_weight = StringField(u'Максимальный объем аудиоматериалов', [v.number_range(min=1)])
    audio_check_interval = StringField(u'Частота проведения очистки аудиоматериалов', [v.required(),
                                                                                       validate_time_interval])


class NetworkServiceConfigForm(TapperUIBaseForm):
    name = StringField(u'Имя', [v.required()])
    address = StringField(u'IP адрес', [v.required(), v.IPAddress()])
    netmask = StringField(u'Маска сети', [v.required(), v.IPAddress(message='Неверная Маска сети.')])
    gateway = StringField(u'Шлюз', [v.optional(), v.IPAddress(message='Неверный Шлюз.')])
