'use strict';

angular.module('fmtapper', ['ngRoute', 'fmtapper.controllers', 'fmtapper.services', 'fmtapper.directives',
    'fmtapper.filters', 'ui.date'])
    .config(['$routeProvider', '$locationProvider','$httpProvider', function($routeProvider, $locationProvider, $httpProvider) {
        $httpProvider.defaults.cache = false;
        if (!$httpProvider.defaults.headers.get) {
          $httpProvider.defaults.headers.get = {};
        }
        // disable IE ajax request caching
        $httpProvider.defaults.headers.get['If-Modified-Since'] = '0';

        $routeProvider.when('/tuners/', {templateUrl: '/static/js/app/partials/list-tuners.html',
            controller: 'ListTunersCtrl'});
        $routeProvider.when('/tuners/edit/:tunerId?', {templateUrl: '/static/js/app/partials/edit-tuner.html',
            controller: 'EditTunerCtrl'});
        $routeProvider.when('/tuners/:tunerId/schedules/', {templateUrl: '/static/js/app/partials/list-schedules.html',
            controller: 'ListSchedulesCtrl'});
        $routeProvider.when('/tuners/:tunerId/schedules/edit/:scheduleName?', {templateUrl: '/static/js/app/partials/edit-schedule.html',
            controller: 'EditScheduleCtrl'});
        $routeProvider.when('/tuners/:tunerId/audio/', {templateUrl: '/static/js/app/partials/list-audio.html',
            controller: 'ListAudioCtrl'});
        $routeProvider.when('/tuners/:tunerId/logs/?', {templateUrl: '/static/js/app/partials/list-logs.html',
            controller: 'ListLogsCtrl'});
        $routeProvider.when('/service', {templateUrl: '/static/js/app/partials/service.html',
            controller: 'EditServiceCtrl'});
        $routeProvider.when('/service/cleanup', {templateUrl: '/static/js/app/partials/cleanup-service.html',
            controller: 'EditCleanupServiceCtrl'});
        $routeProvider.when('/service/cleanup/logs', {templateUrl: '/static/js/app/partials/cleanup-service-logs.html',
            controller: 'ListCleanupServiceLogsCtrl'});
        $routeProvider.when('/logout', {
                                            controller : function(){
                                                window.location.href = '/logout';
                                            },
                                            template : "<div></div>"
                                        });
        $routeProvider.otherwise({redirectTo: '/tuners/'});
    }]).
    run(function($rootScope) {
       $rootScope.isAdmin = CURRENT_USER == 'admin';
    });
