'use strict';

angular.module('fmtapper.filters', [])
    .filter('tuner_status', function() {
        return function(input) {
            var str = typeof input == 'undefined' ? '' : input;
            switch(str) {
                case 0: return 'Запущен';
                case 1: return 'Остановлен';
                default: return 'Статус неизвестен';
            }
        }
    })
    .filter('writing_status', function() {
        return function(input) {
            var str = typeof input == 'undefined' ? '' : input;
            switch(str) {
                case 0: return 'Активна';
                case 1: return 'Не активна';
                default: return 'Статус неизвестен';
            }
        }
    })
    .filter('unixtimestamp', function($filter) {
        return function(input, format) {
            if(input) {
                return $filter('date')(new Date(input * 1000), format);
            }
            else {
                return '';
            }
        }
    })
    .filter('stream_url', function() {
        return function(input) {
            var str = typeof input == 'undefined' ? '' : input;
            return str.replace('/feed', '/stream');
        }
    })
    .filter('writing_format', function() {
        return function(config, is_schedule) {
            if(!config) {
                return '';
            }
            var f = config.fragment_length;
            var l = config.interval_length;
            var msg;
            if(angular.isNumber(f) && angular.isNumber(l) && +f <= +l) {
                msg = 'Фрагментами';
            }
            else {
                msg = 'Непрерывно';
            }
            msg += is_schedule ? ', Расписание' : ', Постоянно';
            return msg;
        }
    })
    .filter('tuner_type', function() {
        return function(input) {
            var str = typeof input == 'undefined' ? '' : input;
            switch(str) {
                case 0: return 'Неуправляемое звуковое устройство';
                case 1: return 'Управляемое звуковое устройство';
                case 2: return 'Блок тюнеров';
                case 3: return 'Интернет радио';
                default: return '';
            }
        }
    })
    .filter('fm_quality', function() {
       return function(quality, status) {
           var res;
           if(!quality || status != 0 || quality <= 0) {
               res = 0;
           }
           else {
               res = quality;
           }
           return res;
       }
    });
